Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4LundStringFragmentation.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4LundStringFragmentation.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4LundStringFragmentation.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4LundStringFragmentation.hh,v 1.4 2007/04/24 14:55:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $ Maxim Komogorov
+// $Id: G4LundStringFragmentation.hh,v 1.6 2008/04/25 14:20:14 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $ Maxim Komogorov
 //
 // -----------------------------------------------------------------------------
@@ -44,32 +44,48 @@
     {
 public:
+
     G4LundStringFragmentation();
-//    G4LundStringFragmentation(G4double sigmaPt);
-     G4LundStringFragmentation(const G4LundStringFragmentation &right);
-     virtual ~G4LundStringFragmentation();
-     virtual G4KineticTrackVector* FragmentString(const G4ExcitedString& theString);
+    G4LundStringFragmentation(const G4LundStringFragmentation &right);
+    virtual ~G4LundStringFragmentation();
 
-public:
     const G4LundStringFragmentation & operator=(const G4LundStringFragmentation &right);
     int operator==(const G4LundStringFragmentation &right) const;
     int operator!=(const G4LundStringFragmentation &right) const;
 
+    virtual G4KineticTrackVector* FragmentString(const G4ExcitedString& theString);
 
 private:
-   virtual G4double GetLightConeZ(G4double zmin, G4double zmax, G4int PartonEncoding,  G4ParticleDefinition* pHadron, G4double Px, G4double Py);      
+   void SetMinimalStringMass(const G4FragmentingString  * const string);		    
+   void SetMinimalStringMass2(const G4double aValue);	
 
-   virtual void Sample4Momentum(G4LorentzVector* Mom, G4double Mass, G4LorentzVector* AntiMom, G4double AntiMass, G4double InitialMass); 
    virtual G4bool StopFragmenting(const G4FragmentingString  * const string);
    virtual G4bool IsFragmentable(const G4FragmentingString * const string);
-   virtual G4LorentzVector * SplitEandP(G4ParticleDefinition * pHadron, G4FragmentingString * string);
+
    virtual G4bool SplitLast(G4FragmentingString * string, 
-		    G4KineticTrackVector * LeftVector,
-		    G4KineticTrackVector * RightVector);
-   void SetMinimalStringMass(const G4FragmentingString  * const string);		    
-   void SetMinimalStringMass2(const G4double aValue);		    
+		            G4KineticTrackVector * LeftVector,
+		            G4KineticTrackVector * RightVector);
 
+   virtual void Sample4Momentum(G4LorentzVector* Mom,     G4double Mass, 
+                                G4LorentzVector* AntiMom, G4double AntiMass, 
+                                G4double InitialMass); 
+
+   virtual G4LorentzVector * SplitEandP(G4ParticleDefinition * pHadron, 
+                                        G4FragmentingString * string,
+                                        G4FragmentingString * newString); // Uzhi
+
+   virtual G4double GetLightConeZ(G4double zmin, G4double zmax, 
+                                  G4int PartonEncoding,  
+                                  G4ParticleDefinition* pHadron,
+                                  G4double Px, G4double Py);      
+	    
 private:
+// ------ For estimation of a minimal string mass ---------------
+   G4double Mass_of_light_quark;
+   G4double Mass_of_heavy_quark;
+   G4double Mass_of_string_junction;
+// ------ An estimated minimal string mass ----------------------
    G4double MinimalStringMass;
    G4double MinimalStringMass2;
+// ------ Minimal invariant mass used at a string fragmentation -
    G4double WminLUND;		    
 };
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4QGSMFragmentation.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4QGSMFragmentation.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4QGSMFragmentation.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QGSMFragmentation.hh,v 1.4 2007/04/24 14:55:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4QGSMFragmentation.hh,v 1.5 2007/12/20 15:38:07 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // -----------------------------------------------------------------------------
@@ -57,5 +57,7 @@
    virtual G4bool StopFragmenting(const G4FragmentingString  * const string);
    virtual G4bool IsFragmentable(const G4FragmentingString * const string);
-   virtual G4LorentzVector * SplitEandP(G4ParticleDefinition * pHadron, G4FragmentingString * string);
+   virtual G4LorentzVector * SplitEandP(G4ParticleDefinition * pHadron, 
+                                        G4FragmentingString * string,     // Uzhi
+                                        G4FragmentingString * newString); // Uzhi
    virtual G4bool SplitLast(G4FragmentingString * string, 
 		    G4KineticTrackVector * LeftVector,
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VKinkyStringDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VKinkyStringDecay.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VKinkyStringDecay.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VKinkyStringDecay.hh,v 1.3 2006/06/29 20:54:53 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //  Maxim Komogorov
 //
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VLongitudinalStringDecay.hh,v 1.4 2007/04/24 14:55:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4VLongitudinalStringDecay.hh,v 1.6 2008/06/23 08:35:54 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 // Maxim Komogorov
 //
@@ -43,15 +43,14 @@
 
 class G4FragmentingString;
-//**********************************************************************************************
+//**************************************************************************************
 
 class G4VLongitudinalStringDecay 
    {
 public:
-   G4VLongitudinalStringDecay();     
+            G4VLongitudinalStringDecay();     
    virtual ~G4VLongitudinalStringDecay();
 
 private:
-//  G4VLongitudinalStringDecay(const G4VLongitudinalStringDecay &right);
-//  const G4VLongitudinalStringDecay & operator=(const G4VLongitudinalStringDecay &right);
+
    int operator==(const G4VLongitudinalStringDecay &right) const;
    int operator!=(const G4VLongitudinalStringDecay &right) const;
@@ -59,6 +58,94 @@
 public:
    virtual G4KineticTrackVector* FragmentString(const G4ExcitedString& theString)=0;
-   
+
+protected: 
+
+// For changing Mass Cut used for selection of very small mass strings
+   virtual void SetMassCut(G4double aValue);
+
+// For handling a string with very low mass
+   G4KineticTrackVector * LightFragmentationTest(const G4ExcitedString * const theString);
+
+// To store created quarks or 2 last hadrons
+   typedef std::pair<G4ParticleDefinition*, G4ParticleDefinition*> pDefPair;
+
+// For creation of hadrons from given quark pair 
+   typedef G4ParticleDefinition * (G4HadronBuilder::*Pcreate)
+		   			(G4ParticleDefinition*, G4ParticleDefinition*);
+
+//-----------------------------------------------------------------------------
+// Used by LightFragmentationTest for estimation of lowest possible mass of
+// given quark system
+   G4double FragmentationMass(const G4FragmentingString * const string,
+		              Pcreate build=0,
+		              pDefPair * pdefs=0);
+
+   G4ParticleDefinition* FindParticle(G4int Encoding); 
+
+   virtual void Sample4Momentum(G4LorentzVector* Mom,     G4double Mass, 
+                                G4LorentzVector* AntiMom, G4double AntiMass, 
+                                G4double InitialMass)=0; 
+//-----------------------------------------------------------------------------
+// For decision on continue or stop string fragmentation
+   virtual G4bool StopFragmenting(const G4FragmentingString  * const string)=0;
+   virtual G4bool IsFragmentable(const G4FragmentingString * const string)=0;
+
+// If a string can not fragment, make last break into 2 hadrons
+   virtual G4bool SplitLast(G4FragmentingString * string, 
+		    G4KineticTrackVector * LeftVector,
+		    G4KineticTrackVector * RightVector)=0;
+//-----------------------------------------------------------------------------
+
+// If a string fragments, do the following
+
+// For transver of a string to its CMS frame
+   G4ExcitedString *CPExcited(const G4ExcitedString& string);
+
+   G4KineticTrack * Splitup(G4FragmentingString *string, 
+                            G4FragmentingString *&newString);
+
+   G4ParticleDefinition * QuarkSplitup(G4ParticleDefinition* decay,
+		   		       G4ParticleDefinition *&created);
+
+   G4ParticleDefinition * DiQuarkSplitup(G4ParticleDefinition* decay,
+		   			 G4ParticleDefinition *&created);
+					
+   pDefPair CreatePartonPair(G4int NeedParticle, G4bool AllowDiquarks=true);
+
+public:
+//   used by G4VKinkyStringDecy..
+   G4int SampleQuarkFlavor(void);
+   G4ThreeVector SampleQuarkPt();
+
+protected:
+
+//-----------------------------------------------------------------------------
+// For determination of kinematical properties of created hadron
+//   virtual G4LorentzVector * SplitEandP(G4ParticleDefinition * pHadron,    // Uzhi
+//                                        G4FragmentingString * string  )=0; // Uzhi
+
+   virtual G4LorentzVector * SplitEandP(G4ParticleDefinition * pHadron,      // Uzhi
+                                        G4FragmentingString * string,        // Uzhi
+                                        G4FragmentingString * newString  )=0;// Uzhi
+
+   virtual G4double GetLightConeZ(G4double zmin, G4double zmax, 
+                                  G4int PartonEncoding,  
+                                  G4ParticleDefinition* pHadron, 
+                                  G4double Px, G4double Py       ) = 0;      
+
+   void CalculateHadronTimePosition(G4double theInitialStringMass, 
+                                    G4KineticTrackVector *);
+
+// Used for some test purposes ------------------------------------------------ 
+   void ConstructParticle();
+
+   G4ParticleDefinition* CreateHadron(G4int id1, G4int id2, 
+                                      G4bool theGivenSpin, G4int theSpin); 
+   
+//-----------------------------------------------------------------------------
+public:
+
    G4KineticTrackVector* DecayResonans (G4KineticTrackVector* aHadrons);
+
    void SetSigmaTransverseMomentum(G4double aQT);
    void SetStrangenessSuppression(G4double aValue);
@@ -72,8 +159,6 @@
    void SetVectorMesonMixings( std::vector<G4double> aVector);
 
-//   used by G4VKinkyStringDecy..
-   G4int SampleQuarkFlavor(void);
-   G4ThreeVector SampleQuarkPt();
-        
+   void SetStringTensionParameter(G4double aValue);            // Uzhi 20 June 08
+
 //private:
 protected:  
@@ -83,12 +168,7 @@
    G4double GetClusterMass()		{return ClusterMass;};
    G4int    GetClusterLoopInterrupt()   {return ClusterLoopInterrupt;};
-   
-   G4ParticleDefinition* CreateHadron(G4int id1, G4int id2, G4bool theGivenSpin, G4int theSpin); 
-   virtual void Sample4Momentum(G4LorentzVector* Mom, G4double Mass, G4LorentzVector* AntiMom, G4double AntiMass, G4double InitialMass)=0; 
-
-protected:
-   // Additional protected declarations 
-   virtual G4double GetLightConeZ(G4double zmin, G4double zmax, G4int PartonEncoding,  G4ParticleDefinition* pHadron, G4double Px, G4double Py) = 0;      
-
+
+   G4double GetStringTensionParameter() {return Kappa;};       // Uzhi 20 June 08
+   
 //private:
 protected:  
@@ -105,6 +185,4 @@
    G4HadronBuilder *hadronizer;
 
-   void ConstructParticle();
-
    G4double pspin_meson;
    G4double pspin_barion;
@@ -113,43 +191,14 @@
    
    G4bool    PastInitPhase;
-   
-
-   G4KineticTrackVector * LightFragmentationTest(const G4ExcitedString * const theString);
-   virtual G4bool StopFragmenting(const G4FragmentingString  * const string)=0;
-   virtual G4bool IsFragmentable(const G4FragmentingString * const string)=0;
+
+   G4double Kappa; // String tension parameter                 // Uzhi 20 June 08
+
 //   G4double MinFragmentationMass(G4ExcitedString * theString,
 //				G4ParticleDefinition*& Hadron1,
 //				G4ParticleDefinition*& Hadron2);
-   typedef std::pair<G4ParticleDefinition*, G4ParticleDefinition*> pDefPair;
-   typedef G4ParticleDefinition * (G4HadronBuilder::*Pcreate)
-		   			(G4ParticleDefinition*, G4ParticleDefinition*);
-   G4double FragmentationMass(
-		const G4FragmentingString * const string,
-		Pcreate build=0,
-		pDefPair * pdefs=0);
-   G4KineticTrack * Splitup(G4FragmentingString *string, G4FragmentingString *&newString);
-   virtual G4LorentzVector * SplitEandP(G4ParticleDefinition * pHadron, G4FragmentingString * string)=0;
-   virtual G4bool SplitLast(G4FragmentingString * string, 
-		    G4KineticTrackVector * LeftVector,
-		    G4KineticTrackVector * RightVector)=0;
-   void CalculateHadronTimePosition(G4double theInitialStringMass, G4KineticTrackVector *);
-   G4ExcitedString *CPExcited(const G4ExcitedString& string);
-   G4ParticleDefinition* FindParticle(G4int Encoding); 
-
-   // Additional Implementation Declarations
-   G4ParticleDefinition * QuarkSplitup(G4ParticleDefinition* decay,
-		   		G4ParticleDefinition *&created);
-   G4ParticleDefinition * DiQuarkSplitup(G4ParticleDefinition* decay,
-		   			G4ParticleDefinition *&created);
-					
-   pDefPair CreatePartonPair(G4int NeedParticle, G4bool AllowDiquarks=true);
-
 
 };
 
-
-//**********************************************************************************************
+//*************************************************************************************
 // Class G4VLongitudinalStringDecay 
 #endif
-
-
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4FragmentingString.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4FragmentingString.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4FragmentingString.cc	(revision 962)
@@ -80,4 +80,7 @@
 	if ( old.decaying == Left )
 	{
+//G4cout<<" Left "<<G4endl;
+//G4cout<<"Pt right "<<Ptright<<G4endl;
+//G4cout<<"Pt left  "<<Ptleft <<G4endl;
 		RightParton= old.RightParton;
 		Ptright    = old.Ptright;
@@ -85,6 +88,11 @@
 		Ptleft     = old.Ptleft - momentum->vect();
 		Ptleft.setZ(0.);
+//G4cout<<"Pt right "<<Ptright<<G4endl;
+//G4cout<<"Pt left  "<<Ptleft <<G4endl;
 	} else if ( old.decaying == Right )
 	{
+//G4cout<<" Right "<<G4endl;
+//G4cout<<"Pt right "<<Ptright<<G4endl;
+//G4cout<<"Pt left  "<<Ptleft <<G4endl;
 		RightParton = newdecay;
 		Ptright     = old.Ptright - momentum->vect();
@@ -92,4 +100,6 @@
 		LeftParton  = old.LeftParton;
 		Ptleft      = old.Ptleft;
+//G4cout<<"Pt right "<<Ptright<<G4endl;
+//G4cout<<"Pt left  "<<Ptleft <<G4endl;
 	} else
 	{
@@ -106,4 +116,25 @@
 //---------------------------------------------------------------------------------
 
+G4FragmentingString::G4FragmentingString(const G4FragmentingString &old,  // Uzhi
+					 G4ParticleDefinition * newdecay) // Uzhi
+{                                                                         // Uzhi
+	decaying=None;                                                    // Uzhi
+	if ( old.decaying == Left )                                       // Uzhi
+	{                                                                 // Uzhi
+		RightParton= old.RightParton;                             // Uzhi
+		LeftParton = newdecay;                                    // Uzhi
+	} else if ( old.decaying == Right )                               // Uzhi
+	{                                                                 // Uzhi
+		RightParton = newdecay;                                   // Uzhi
+		LeftParton  = old.LeftParton;                             // Uzhi
+	} else                                                            // Uzhi
+	{
+		throw G4HadronicException(__FILE__, __LINE__, "G4FragmentingString::G4FragmentingString: no decay Direction defined");
+	}
+}
+
+
+//---------------------------------------------------------------------------------
+
 G4FragmentingString::~G4FragmentingString()
 {}
@@ -215,2 +246,7 @@
 	return std::sqrt(this->Mass2());
 }
+
+G4double G4FragmentingString::MassT2() const
+{
+	return Pplus*Pminus;
+}
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4HadronBuilder.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4HadronBuilder.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4HadronBuilder.cc	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4HadronBuilder.cc,v 1.6 2006/06/29 20:55:01 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: G4HadronBuilder.cc,v 1.7 2008/04/25 14:20:14 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // -----------------------------------------------------------------------------
